'  MAP MAKER

'Hold mouse button or ~ to scroll map
'<  >  changes enemy to be placed
'Scroll wheel zooms in and out
'[ ]  Changes Width
': "  Changes Height
'S Saves
'Left click to add enemy
'Right click to remove enemy  (nearest enemy is circled in red)
'Shift - Rapid add/remove enemies

'Many level/game features are currently hardcoded


SCREEN _NEWIMAGE(800, 600, 32)
Layer = _NEWIMAGE(800, 600)
DrawLayer = _NEWIMAGE(800, 600)
_SCREENMOVE _MIDDLE
_DEST Layer


CONST Rad = 180 / 3.14159265

DIM SHARED MouseX AS INTEGER, MouseY AS INTEGER
DIM SHARED MouseLB AS _BIT, MouseRB AS _BIT, MouseMB AS _BIT
DIM SHARED MouseScrl AS _BYTE
DIM SHARED PicType AS _BYTE

DIM SHARED MainDir AS STRING, DataDir AS STRING, PicDir AS STRING

MainDir = "air attack\"
DataDir = MainDir + "data\"
PicDir = MainDir + "pics\"


TYPE EnemyStats
  MaxSpeed AS SINGLE
  Armor AS LONG
  Thrust AS SINGLE
  Turn AS SINGLE
  FileName AS STRING * 16
  Name AS STRING * 16
  Engage AS LONG
  Ground AS _BYTE '        Is it confined to the ground?  '1 = yes (tank) '0 = no (jet)
  Collect AS _BYTE '       Can you collect it? Powerup?
  PowerUp AS LONG '        How much does it affect the affected stat?
  Affect AS INTEGER '      What stat does it affect?  Make a list.
  Size AS INTEGER '        How big is it?
END TYPE

DIM EnemyStats(100) AS EnemyStats

IF _FILEEXISTS(DataDir + "bad.jml") THEN
  OPEN DataDir + "bad.jml" FOR BINARY AS #1
  GET #1, , EnemyStats()
  CLOSE #1
END IF

Ships = 0
FOR i = 1 TO 100
  IF EnemyStats(i).Size > 0 THEN: Ships = Ships + 1
NEXT


TYPE Enemy
  X AS LONG
  Y AS LONG
  Which AS INTEGER ' Which object/enemy, etc.
  Type AS INTEGER '  Type of object.  Enemy, Building.
  Use AS _BYTE
END TYPE

TYPE Level
  Width AS LONG
  Height AS LONG
  Sky AS INTEGER
  Ground AS INTEGER
  StartX AS LONG
  StartY AS LONG
END TYPE

DIM SHARED Enemy(15, 5000) AS Enemy
DIM SHARED EnemySave(15, 5000) AS Enemy
DIM SHARED Level(15) AS Level
DIM TempPic(150, 100) AS LONG

FOR i = 1 TO 15
  Level(i).Width = 1000
  Level(i).Height = 1000
NEXT

DIM SHARED Pic(Ships)

FOR i = 1 TO Ships
  Pic(i) = _NEWIMAGE(150, 100)
  _DEST Pic(i)
  File$ = PicDir + RTRIM$(EnemyStats(i).FileName) + ".jml"

  OPEN File$ FOR BINARY AS #1
  GET #1, , PicType
  FOR j = 1 TO 5
    GET #1, , TempPic()
  NEXT
  FOR x = 0 TO 149
    FOR y = 0 TO 99
      PSET (x, y), TempPic(x, y)
    NEXT
  NEXT
  _CLEARCOLOR _RGB32(0, 0, 0)
  CLOSE #1
NEXT


_DEST Layer

IF _FILEEXISTS(DataDir + "mapinfo.jml") THEN
  OPEN DataDir + "mapinfo.jml" FOR BINARY AS #1
  GET #1, , Enemy()
  GET #1, , Level()
  CLOSE #1
END IF


DO
  CLS

  LINE (15, 15)-(785, 485), _RGB32(0, 0, 200), BF
  LINE (20, 20)-(780, 480), _RGB32(0, 0, 0), BF


  Mouse

  _LIMIT 30

  OldZoom = Zoom
  Press = _KEYHIT
  SELECT CASE Press
    CASE 96, 126 '~
      IF Scrolling = 0 THEN
        Scrolling = 1
        ScrollX = MouseX
        ScrollY = MouseY
      END IF
    CASE -96, -126
      Scrolling = 0
    CASE 44, 60 '<
      CurEnemy = CurEnemy - 1
    CASE 46, 62 '>
      CurEnemy = CurEnemy + 1
    CASE 91, 123 '[
      Level(CurLev).Width = Level(CurLev).Width - 100
    CASE 93, 125 ']
      Level(CurLev).Width = Level(CurLev).Width + 100
    CASE 58, 59 ':
      Level(CurLev).Height = Level(CurLev).Height - 100
    CASE 34, 39 '"
      Level(CurLev).Height = Level(CurLev).Height + 100
    CASE 45, 95 '-
      Zoom = Zoom + 1
    CASE 43, 61 '+
      Zoom = Zoom - 1
    CASE 82, 114 '  R
      IF RealSize = 0 THEN
        RealSize = 1
      ELSE
        RealSize = 0
      END IF
    CASE 100304, 100303: MultiHold = 1
    CASE -100304, -100303: MultiHold = 0
    CASE 83, 115 '  S

      FOR L = 1 TO 15
        Limit = 5000
        DO
          Switch = 0
          FOR i = 1 TO (Limit - 1)
            IF Enemy(L, i).Use < Enemy(L, i + 1).Use THEN
              SWAP Enemy(L, i), Enemy(L, i + 1)
              Switch = i
            END IF
          NEXT
          Limit = Switch
        LOOP WHILE Switch
      NEXT

      IF _FILEEXISTS(DataDir + "mapinfo.jml") THEN: KILL DataDir + "mapinfo.jml"
      OPEN DataDir + "mapinfo.jml" FOR BINARY AS #1
      PUT #1, , Enemy()
      PUT #1, , Level()
      CLOSE #1
    CASE 88, 120 'X
      Level(CurLev).StartX = MapX
      Level(CurLev).StartY = MapY
  END SELECT

  IF MouseScrl <> 0 THEN
    Zoom = Zoom + MouseScrl
    MouseScrl = 0
  END IF

  IF Level(CurLev).Width < 100 THEN: Level(CurLev).Width = 100
  IF Level(CurLev).Height < 100 THEN: Level(CurLev).Height = 100
  IF Zoom < 1 THEN: Zoom = 1
  IF Zoom > 20 THEN: Zoom = 20

  IF CurEnemy < 1 THEN: CurEnemy = 1
  IF CurEnemy > Ships THEN: CurEnemy = Ships

  IF OldZoom <> Zoom THEN
    XMove = (MapX / Zoom) + 400 - MouseX
    YMove = (MapY / Zoom) + 250 - MouseY
  END IF

  _PUTIMAGE (600, 490)-(750, 590), Pic(CurEnemy)
  _PRINTSTRING (500, 500), STR$(CurEnemy)
  _PRINTSTRING (500, 520), EnemyStats(CurEnemy).Name
  _PRINTSTRING (500, 540), "Count: " + STR$(TotalCur)

  IF Scrolling = 1 THEN
    CurX = MouseX
    CurY = MouseY
    ScrollAngle = Angle(ScrollX, ScrollY, CurX, CurY)
    ScrollSpeed = Distance(ScrollX, ScrollY, CurX, CurY) / 15
    IF ScrollSpeed > 0 THEN
      XMove = XMove + COS(ScrollAngle / Rad) * ScrollSpeed
      YMove = YMove + SIN(ScrollAngle / Rad) * ScrollSpeed
    END IF

  END IF


  IF MouseX <= 780 AND MouseX >= 20 AND MouseY <= 480 AND MouseY >= 20 THEN
    IF MouseMB THEN
      IF MClick = 0 THEN
        MClick = 1
        ScrollX = MouseX
        ScrollY = MouseY
      ELSE
        Scrolling = 1
      END IF
    ELSE
      IF MClick = 1 THEN
        MClick = 0
        Scrolling = 0
      END IF
    END IF
  END IF

  IF MouseLB THEN
    IF LClick = 0 OR MultiHold = 1 THEN
      LClick = 1
      SELECT CASE MouseY
        CASE 20 TO 480
          SELECT CASE MouseX
            CASE 20 TO 780
              IF MapX > -Level(CurLev).Width / 2 AND MapX < Level(CurLev).Width / 2 AND MapY > -Level(CurLev).Height / 2 AND MapY < Level(CurLev).Height < 2 THEN
                FOR i = 1 TO 5000
                  IF Enemy(CurLev, i).Use = 0 THEN
                    Enemy(CurLev, i).X = MapX
                    Enemy(CurLev, i).Y = MapY
                    Enemy(CurLev, i).Type = CurEnemy
                    Enemy(CurLev, i).Use = 1
                    EXIT FOR
                  END IF
                NEXT
              END IF
          END SELECT
        CASE 538 TO 554
          SELECT CASE MouseX
            CASE 18 TO 28: Level(CurLev).Width = Level(CurLev).Width - 100
            CASE 130 TO 140: Level(CurLev).Width = Level(CurLev).Width + 100
            CASE 198 TO 208: Level(CurLev).Height = Level(CurLev).Height - 100
            CASE 310 TO 320: Level(CurLev).Height = Level(CurLev).Height + 100
            CASE 368 TO 378: CurLev = CurLev - 1
            CASE 440 TO 450: CurLev = CurLev + 1
          END SELECT
      END SELECT
    END IF
  ELSE
    LClick = 0
  END IF

  IF CurLev < 1 THEN: CurLev = 1
  IF CurLev > 15 THEN: CurLev = 15


  IF MouseRB THEN
    IF RClick = 0 OR MultiHold = 1 THEN
      RClick = 1
      IF CloseEnemy > 0 THEN: Enemy(CurLev, CloseEnemy).Use = 0
    END IF
  ELSE
    RClick = 0
  END IF

  MapX = (MouseX - 400 + XMove) * Zoom
  MapY = (MouseY - 250 + YMove) * Zoom

  XMin = -Level(CurLev).Width / 2 + 380
  YMin = -Level(CurLev).Height / 2 + 230
  XMax = Level(CurLev).Width / 2 - 380
  YMax = Level(CurLev).Height / 2 - 230

  IF XMove < XMin THEN: XMove = XMin
  IF XMove > XMax THEN: XMove = XMax
  IF YMove < YMin THEN: YMove = YMin
  IF YMove > YMax THEN: YMove = YMax


  _PRINTSTRING (0, 0), STR$(MouseX) + "  " + STR$(MouseY)
  _PRINTSTRING (400, 0), STR$(MapX) + " " + STR$(MapY)
  _PRINTSTRING (360, 500), "Total: " + STR$(Total)


  _PRINTSTRING (20, 500), STR$(XMove) + "," + STR$(YMove)

  _PRINTSTRING (20, 540), CHR$(17) + " Map X Width " + CHR$(16)
  _PRINTSTRING (40, 560), STR$(Level(CurLev).Width)
  _PRINTSTRING (200, 540), CHR$(17) + " Map Y Width " + CHR$(16)
  _PRINTSTRING (240, 560), STR$(Level(CurLev).Height)
  _PRINTSTRING (370, 540), CHR$(17) + " CurLev " + CHR$(16)
  _PRINTSTRING (390, 560), STR$(CurLev)


  _PRINTSTRING (600, 0), "Zoom: " + STR$(21 - Zoom)


  _DEST DrawLayer
  _PRINTMODE _KEEPBACKGROUND
  CLS

  BorderX = (Level(CurLev).Width / 2) / Zoom
  BorderY = (Level(CurLev).Height / 2) / Zoom
  LINE (-BorderX + 400 - XMove, -BorderY + 250 - YMove)-(BorderX + 400 - XMove, BorderY + 250 - YMove), _RGB32(255, 255, 255), B

  Total = 0
  TotalCur = 0
  Closest = 100000
  CloseEnemy = 0
  FOR i = 1 TO 5000
    IF Enemy(CurLev, i).Use = 1 THEN
      Dist = Distance(Enemy(CurLev, i).X, Enemy(CurLev, i).Y, MapX, MapY)
      IF Dist < Closest THEN
        Closest = Dist
        CloseEnemy = i
      END IF
      Total = Total + 1
      IF Enemy(CurLev, i).Type = CurEnemy THEN: TotalCur = TotalCur + 1
      EnemyX = Enemy(CurLev, i).X / Zoom - XMove + 400
      EnemyY = Enemy(CurLev, i).Y / Zoom - YMove + 250

      SELECT CASE RealSize
        CASE 0
          XSize = 100 / Zoom
        CASE 1
          XSize = EnemyStats(Enemy(CurLev, i).Type).Size / 2 / Zoom
      END SELECT
      YSize = XSize / 1.5
      _PUTIMAGE (EnemyX - XSize, EnemyY - YSize)-(EnemyX + XSize, EnemyY + YSize), Pic(Enemy(CurLev, i).Type)
      '_PRINTSTRING (EnemyX, EnemyY), STR$(i)
      'CIRCLE (Enemy(CurLev,i).X / 10 - XMove + 400, Enemy(CurLev,i).Y / 10 - YMove + 250), 20
      '_PRINTSTRING (Enemy(CurLev,i).X / 10 - XMove + 400, Enemy(CurLev,i).Y / 10 - YMove + 250), STR$(Enemy(CurLev,i).Type)
    END IF
  NEXT

  IF CloseEnemy > 0 THEN
    SELECT CASE RealSize
      CASE 0
        CIRCLE (Enemy(CurLev, CloseEnemy).X / Zoom - XMove + 400, Enemy(CurLev, CloseEnemy).Y / Zoom - YMove + 250), 30, _RGB32(255, 0, 0)
      CASE 1
        CIRCLE (Enemy(CurLev, CloseEnemy).X / Zoom - XMove + 400, Enemy(CurLev, CloseEnemy).Y / Zoom - YMove + 250), EnemyStats(Enemy(CurLev, CloseEnemy).Type).Size / 2 / Zoom, _RGB32(255, 0, 0)
    END SELECT
  END IF

  CIRCLE ((Level(CurLev).StartX / Zoom) + 400 - XMove, (Level(CurLev).StartY / Zoom) + 250 - YMove), 20

  _PRINTSTRING (MouseX + 10, MouseY - 15), EnemyStats(Enemy(CurLev, CloseEnemy).Type).Name
  _PRINTSTRING (MouseX + 10, MouseY), STR$(Enemy(CurLev, CloseEnemy).Type)
  _PRINTSTRING (MouseX + 10, MouseY + 15), STR$(CloseEnemy)


  _DEST Layer

  _PUTIMAGE (20, 20)-(780, 480), DrawLayer, Layer, (20, 20)-(780, 480)
  PCOPY Layer, 0
LOOP








SUB Mouse
DO WHILE _MOUSEINPUT
  MouseX = _MOUSEX
  MouseY = _MOUSEY
  MouseLB = _MOUSEBUTTON(1)
  MouseRB = _MOUSEBUTTON(2)
  MouseMB = _MOUSEBUTTON(3)
  MouseScrl = MouseScrl + _MOUSEWHEEL
LOOP
IF MouseScrl < -1 THEN: MouseScrl = -1
IF MouseScrl > 1 THEN: MouseScrl = 1
END SUB

FUNCTION Distance (X1, Y1, X2, Y2)
Distance = SQR((X1 - X2) * (X1 - X2) + (Y1 - Y2) * (Y1 - Y2))
END FUNCTION

FUNCTION Angle (X1, Y1, X2, Y2)
Ang = ATN((X1 - X2) / (Y1 - Y2)) * Rad
IF Y1 >= Y2 THEN
  Angle = 270 - Ang
ELSE
  Angle = 90 - Ang
END IF
END FUNCTION

